"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TNSRTCBundlePolicy_1 = require("../core/TNSRTCBundlePolicy");
var TNSRTCRtcpMuxPolicy_1 = require("../core/TNSRTCRtcpMuxPolicy");
var TNSRTCConfigurationBase_1 = require("../base/TNSRTCConfigurationBase");
var TNSRTCIceTransportPolicy_1 = require("../core/TNSRTCIceTransportPolicy");
var TNSRTCSdpSemantics_1 = require("../core/TNSRTCSdpSemantics");
var TNSRTCConfiguration = (function (_super) {
    __extends(TNSRTCConfiguration, _super);
    function TNSRTCConfiguration(options) {
        var _this = _super.call(this, options) || this;
        if (Array.isArray(options.iceServers)) {
            if (options.iceServers != null) {
                var count = options.iceServers.length;
                var nativeArray = new java.util.ArrayList();
                for (var i = 0; i < count; i++) {
                    var server = options.iceServers[i];
                    nativeArray.add(server.instance);
                }
                _this._configuration = new co.fitcom.fancywebrtc.FancyRTCConfiguration(nativeArray);
            }
            else {
                _this._configuration = new co.fitcom.fancywebrtc.FancyRTCConfiguration();
            }
            if (options.bundlePolicy != null) {
                switch (options.bundlePolicy) {
                    case TNSRTCBundlePolicy_1.TNSRTCBundlePolicy.BALANCED:
                        _this._configuration.setBundlePolicy(co.fitcom.fancywebrtc.FancyRTCBundlePolicy.BALANCED);
                        break;
                    case TNSRTCBundlePolicy_1.TNSRTCBundlePolicy.MAX_BUNDLE:
                        _this._configuration.setBundlePolicy(co.fitcom.fancywebrtc.FancyRTCBundlePolicy.MAX_BUNDLE);
                        break;
                    case TNSRTCBundlePolicy_1.TNSRTCBundlePolicy.MAX_COMPAT:
                        _this._configuration.setBundlePolicy(co.fitcom.fancywebrtc.FancyRTCBundlePolicy.MAX_COMPAT);
                        break;
                }
            }
            if (options.iceCandidatePoolSize != null) {
                _this._configuration.setIceCandidatePoolSize(options.iceCandidatePoolSize);
            }
            if (options.rtcpMuxPolicy != null) {
                switch (options.rtcpMuxPolicy) {
                    case TNSRTCRtcpMuxPolicy_1.TNSRTCRtcpMuxPolicy.NEGOTIATE:
                        _this._configuration.setIceTransportPolicy(co.fitcom.fancywebrtc.FancyRTCRtcpMuxPolicy.NEGOTIATE);
                        break;
                    case TNSRTCRtcpMuxPolicy_1.TNSRTCRtcpMuxPolicy.REQUIRE:
                        _this._configuration.setIceTransportPolicy(co.fitcom.fancywebrtc.FancyRTCRtcpMuxPolicy.REQUIRE);
                        break;
                }
            }
            if (options.iceTransportPolicy != null) {
                switch (options.iceTransportPolicy) {
                    case TNSRTCIceTransportPolicy_1.TNSRTCIceTransportPolicy.ALL:
                        _this._configuration.setIceTransportPolicy(co.fitcom.fancywebrtc.FancyRTCIceTransportPolicy.ALL);
                        break;
                    case TNSRTCIceTransportPolicy_1.TNSRTCIceTransportPolicy.PUBLIC:
                        _this._configuration.setIceTransportPolicy(co.fitcom.fancywebrtc.FancyRTCIceTransportPolicy.PUBLIC);
                        break;
                    case TNSRTCIceTransportPolicy_1.TNSRTCIceTransportPolicy.RELAY:
                        _this._configuration.setIceTransportPolicy(co.fitcom.fancywebrtc.FancyRTCIceTransportPolicy.RELAY);
                        break;
                }
            }
            if (options.sdpSemantics != null) {
                switch (options.sdpSemantics) {
                    case TNSRTCSdpSemantics_1.TNSRTCSdpSemantics.PLAN_B:
                        _this._configuration.setSdpSemantics(co.fitcom.fancywebrtc.FancyRTCSdpSemantics.PLAN_B);
                        break;
                    case TNSRTCSdpSemantics_1.TNSRTCSdpSemantics.UNIFIED_PLAN:
                        _this._configuration.setSdpSemantics(co.fitcom.fancywebrtc.FancyRTCSdpSemantics.UNIFIED_PLAN);
                        break;
                }
            }
            if (options.peerIdentity) {
                _this._configuration.setPeerIdentity(options.peerIdentity);
            }
        }
        else {
            _this._configuration = new co.fitcom.fancywebrtc.FancyRTCConfiguration();
        }
        return _this;
    }
    Object.defineProperty(TNSRTCConfiguration.prototype, "instance", {
        get: function () {
            return this._configuration;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCConfiguration.prototype, "android", {
        get: function () {
            return this._configuration.getConfiguration();
        },
        enumerable: true,
        configurable: true
    });
    return TNSRTCConfiguration;
}(TNSRTCConfigurationBase_1.TNSRTCConfigurationBase));
exports.TNSRTCConfiguration = TNSRTCConfiguration;
//# sourceMappingURL=TNSRTCConfiguration.js.map