"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TNSRTCTrackEventBase_1 = require("../base/TNSRTCTrackEventBase");
var TNSRTCMediaStreamTrack_1 = require("./TNSRTCMediaStreamTrack");
var TNSRTCRtpTransceiver_1 = require("./TNSRTCRtpTransceiver");
var TNSRTCRtpReceiver_1 = require("./TNSRTCRtpReceiver");
var TNSRTCMediaStream_1 = require("./TNSRTCMediaStream");
var TNSRTCTrackEvent = (function (_super) {
    __extends(TNSRTCTrackEvent, _super);
    function TNSRTCTrackEvent(event) {
        var _this = _super.call(this, event) || this;
        _this._event = event;
        var track = _this._event.getMediaTrack();
        _this._mediaTrack = track ? TNSRTCMediaStreamTrack_1.TNSRTCMediaStreamTrack.fromNative(track) : null;
        var transceiver = _this._event.getTransceiver();
        _this._transceiver = transceiver ? TNSRTCRtpTransceiver_1.TNSRTCRtpTransceiver.fromNative(transceiver) : null;
        var receiver = event.getReceiver();
        _this._receiver = receiver ? TNSRTCRtpReceiver_1.TNSRTCRtpReceiver.fromNative(receiver) : null;
        var array = [];
        var nativeArray = _this._event.getStreams();
        if (nativeArray) {
            var size = nativeArray.size();
            for (var i = 0; i < size; i++) {
                var stream = nativeArray.get(i);
                array.push(TNSRTCMediaStream_1.TNSRTCMediaStream.fromNative(stream));
            }
        }
        _this._streams = array;
        return _this;
    }
    Object.defineProperty(TNSRTCTrackEvent.prototype, "track", {
        get: function () {
            return this.mediaTrack;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "mediaTrack", {
        get: function () {
            return this._mediaTrack;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "transceiver", {
        get: function () {
            return this._transceiver;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "receiver", {
        get: function () {
            return this._receiver;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TNSRTCTrackEvent.prototype, "streams", {
        get: function () {
            return this._streams;
        },
        enumerable: true,
        configurable: true
    });
    TNSRTCTrackEvent.fromNative = function (event) {
        return new TNSRTCTrackEvent(event);
    };
    return TNSRTCTrackEvent;
}(TNSRTCTrackEventBase_1.TNSRTCTrackEventBase));
exports.TNSRTCTrackEvent = TNSRTCTrackEvent;
//# sourceMappingURL=TNSRTCTrackEvent.js.map